import React, { useState, useEffect } from 'react';
import { highlight } from 'sugar-high';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var _excluded = ["value", "onChange"];
var styles = {
  pad: {
    display: 'inline-block',
    overflowWrap: 'break-word'
  },
  pre: {
    margin: '0px',
    whiteSpace: 'pre-wrap'
  },
  input: {
    position: 'absolute',
    left: 0,
    right: 0,
    top: 0,
    bottom: 0,
    resize: 'none',
    display: 'block',
    color: 'var(--editor-text-color)',
    backgroundColor: 'var(--editor-background-color)'
  }
};

var inputStyle = _extends({}, styles.pad, styles.input);

function Editor(_ref) {
  var _ref$value = _ref.value,
      value = _ref$value === void 0 ? '' : _ref$value,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(value),
      text = _useState[0],
      setText = _useState[1];

  var _useState2 = useState(highlight(text)),
      output = _useState2[0],
      setOutput = _useState2[1];

  function update(code) {
    var highlighted = highlight(code);
    setText(code);
    setOutput(highlighted);
    onChange(code);
  }

  useEffect(function () {
    update(value);
  }, [value]);

  function onInput(event) {
    var code = event.target.value || '';
    update(code);
  }

  return /*#__PURE__*/React.createElement("div", props, /*#__PURE__*/React.createElement("pre", {
    style: styles.pre
  }, /*#__PURE__*/React.createElement("code", {
    style: styles.pad,
    dangerouslySetInnerHTML: {
      __html: output
    }
  })), /*#__PURE__*/React.createElement("textarea", {
    style: inputStyle,
    value: text,
    onChange: onInput
  }));
}

export { Editor };
